__kernel void 
convolute(
	__global int *inputImage,
	__global int *inputMask,
	__global int *answer,
	__global int inputWidth,
	__global int maskSize
	)
{
	//This will be called for each pixel with coords col,row
	int col = get_global_id(0);
	int row = get_global_id(1);
	
	int sum = 0;
	int im = 0;
	int m;
	int n;
	
	for (m=0; m< maskSize; m++)
		for (n=0; n< maskSize; n++)
		{
			int ms = inputMask[m*maskSize+n];
			int idx = col - m;
			int jdx = row - n;
			if (idx >= 0 && jdx >= 0)
				im = inputImage[jdx*inputWidth+idx];
			sum += ms * im;
		}

	if (sum > 255) sum = 255;
	if (sum < 0) sum = 0;

	int indexOut = row*inputWidth+col;
	answer[indexOut] = sum;
	
}